#!/bin/sh
echo Detect Large Flash Storage /etc/init.d/boottime/detectbigflash.sh

# ---------------------------------------------------------------------------------------
switch_drive() {
	# does 	using_mnt_flash exist?
  if [ -e /usr/local/bin/using_mnt_flash ];
	then
		echo Storage found. Using /mnt/flash.
		exit 0 # success
	fi	

	# does using_usb_flash exist
  if [ -e /usr/local/bin/using_usb_flash ];
	then
		echo Storage found sda1, remapping var/local, using /mnt/3.
    rm /var/local
    ln -s /mnt/3/local /var/local
		exit 0 # success
	fi	
		
  # has the "switch to local" setting been set?
  if [ -e /usr/local/bin/switch_to_mnt_flash ];
	then
		echo Storage found. Moving data from usb to /mnt/flash
	  # move data files back to normal folder here, and set database to rw mode.
		cp -a /mnt/3/local/* /mnt/flash/varlocal
    rm /var/local
    ln -s /mnt/flash/varlocal /var/local
		chmod -R a+rwx /var/local/*
		# create use_mnt_flash
		mv /usr/local/bin/switch_to_mnt_flash /usr/local/bin/using_mnt_flash
		exit 0 # success
	fi

	# has the "switch to usb" setting been set?
  if [ -e /usr/local/bin/switch_to_usb_flash ];
	then
		echo Storage found. Moving data from /mnt/flash to usb
	  # move data files to flash, and remap flash folder
		cp -a /var/local /mnt/3
    rm /var/local
    ln -s /mnt/3/local /var/local
		chmod -R a+rwx /var/local/*
		mv /usr/local/bin/switch_to_usb_flash /usr/local/bin/using_usb_flash
		exit 0 # success
  fi
	
  if [ -e /mnt/3/local/data/update_type ];
	then
	  cp /usr/local/bin/setip.sh /usr/local/bin/using_usb_flash
		echo Storage found sda1, remapping var/local
    rm /var/local
    ln -s /mnt/3/local /var/local
	else
	  echo New storage found sda, copying from old and remapping var/local
		cp -a /var/local /mnt/3
    rm /var/local
    ln -s /mnt/3/local /var/local
		cp /usr/local/bin/setip.sh /usr/local/bin/using_usb_flash
  fi	
	exit 0 # success
}

# it's important to _mount_ the internal usb to /mnt/3 even if it's not being used
# otherwise it will interfere with backup / sync / restore usb functionality
mount -t vfat -o umask=0000 /dev/sda1 /mnt/3 > /dev/null 2>&1
if [ -e /mnt/3/CSTimeClockFixedStorage_DNR ];
then
  switch_drive
else
  umount /mnt/3 > /dev/null 2>&1
  mount -t vfat -o umask=0000 /dev/sda /mnt/3 > /dev/null 2>&1
  if [ -e /mnt/3/CSTimeClockFixedStorage_DNR ];
  then
    switch_drive
	else
    umount /mnt/3 > /dev/null 2>&1
    mount -t vfat -o umask=0000 /dev/sdb1 /mnt/3 > /dev/null 2>&1
    if [ -e /mnt/3/CSTimeClockFixedStorage_DNR ];
    then
      switch_drive
	  else
      umount /mnt/3	> /dev/null 2>&1
      mount -t vfat -o umask=0000 /dev/sdb /mnt/3 > /dev/null 2>&1
			if [ -e /mnt/3/CSTimeClockFixedStorage_DNR ];
			then
				switch_drive
			else
				echo Large Flash Storage not found
				if [ -e /usr/local/bin/using_usb_flash ];
				then 
					mv /usr/local/bin/using_usb_flash /usr/local/bin/using_mnt_flash
				fi
				if [ -e /mnt/3/local/data/switch_to_usb_flash ];
				then
					mv /usr/local/bin/switch_to_usb_flash /usr/local/bin/using_mnt_flash
				fi
				if [ -e /usr/local/bin/switch_to_mnt_flash ];
				then
					mv /usr/local/bin/switch_to_mnt_flash /usr/local/bin/using_mnt_flash
				fi
				if [ -e /usr/local/bin/using_mnt_flash ];
				then
					echo Using /mnt/flash
				else
					cp /usr/local/bin/setip.sh /usr/local/bin/using_mnt_flash
				fi
			fi		
		fi	
	fi	
fi

# dmesg | grep -i "SCSI device" 

# to switch from internal flash to usb flash change file
# /usr/local/bin/using_mnt_flash to 
# /usr/local/bin/switch_to_usb_flash eg
# mv /usr/local/bin/using_mnt_flash /usr/local/bin/switch_to_usb_flash
# then reboot

# to switch from usb flash to mount flash change file
# /usr/local/bin/using_usb_flash to 
# /usr/local/bin/switch_to_mnt_flash eg
# mv /usr/local/bin/using_usb_flash /usr/local/bin/switch_to_mnt_flash
# then reboot

# to see what it is currently set to do a
# ls -l /var/local
# if result shows /mnt/3/local then using usb
# if result shows /mnt/flash/varlocal then using mnt




